/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package edu.cmu.taghelpertools.experiments;


import java.io.File;
import java.util.HashMap;
import java.util.Iterator;


import edu.cmu.taghelpertools.io.Reader;
import edu.cmu.taghelpertools.util.GenericNode;
import edu.cmu.taghelpertools.util.GenericNodeSorter;


public class ContractionFinder {

    public static void main(String args[]) {
        HashMap contMap = new HashMap();
        File dir = new File("D:/corpus/restaurant/broadcast_news/");


        String[] files = dir.list();

        for (int i = 0; i < files.length; i++) {
            System.out.println(i + "," + files.length);
            Reader reader = new Reader(dir.getAbsolutePath() + "/" + files[i]);
            String line = "";
            while ((line = reader.readLine()) != null) {
                String[] split = line.split(" ");
                for (int j = 0; j < split.length; j++) {
                    if (split[j].indexOf("" + "'") != -1) {
                        if (contMap.containsKey(split[j])) {
                            int count = ((Integer) contMap.get(split[j])).intValue();
                            count++;
                            contMap.put(split[j], new Integer(count));
                        } else {
                            contMap.put(split[j], new Integer(1));
                        }
                    }
                }
            }
        }
        GenericNodeSorter gs = GenericNodeSorter.getNewInstance();
        Iterator iter = contMap.keySet().iterator();
        while (iter.hasNext()) {
            String term = iter.next().toString();
            gs.addGenericNode(new GenericNode(term, ((Integer) contMap.get(term)).doubleValue()));
        }
        Object[] objs = gs.getAllGenericNodes();

        for (int i = 0; i < objs.length; i++) {
            System.out.println(((GenericNode) objs[i]).getO().toString().toLowerCase());
        }
    }
}
