/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package edu.cmu.taghelpertools.experiments;


import java.io.File;

import edu.cmu.taghelpertools.io.Logger;
import edu.cmu.taghelpertools.io.Reader;


public class FractionsFileWriter {

    public static void main(String args[]) {
        FractionsFileWriter ffw = new FractionsFileWriter();
        ffw.runTuTalkInput();
    }

    public void runTuTalkInput() {
        File dir = new File("data/fractions/");
        String[] files = dir.list();
        for (int i = 0; i < files.length; i++) {
            Logger logger = new Logger(files[i]);
            Reader reader = new Reader(dir.getAbsolutePath() + "/" + files[i]);
            String line = "";
            while ((line = reader.readLine()) != null) {
                line = line.trim();
                String[] split = line.split(",");
                String student = split[0];
                String text = "" + '"';
                for (int j = 2; j < split.length; j++) {
                    if (j == 2) {
                        text += split[j];
                    } else {
                        text += (", " + split[j]);
                    }
                }
                text += '"';
                logger.writeLine(student + ",," + text);
            }
            logger.close();
        }
    }


    public void run() {
        File dir = new File("data/fractions/");
        String[] files = dir.list();
        Logger logger = new Logger("fractions.csv");
        for (int i = 0; i < files.length; i++) {
            Reader reader = new Reader(dir.getAbsolutePath() + "/" + files[i]);
            String line = "";
            while ((line = reader.readLine()) != null) {
                line = line.trim();
                String[] split = line.split(",");
                String student = split[0];
                String label = split[1];
                String text = "" + '"';
                for (int j = 2; j < split.length; j++) {
                    if (j == 2) {
                        text += split[j];
                    } else {
                        text += (", " + split[j]);
                    }
                }
                text += '"';
                logger.writeLine(label + "," + text);
            }
        }
        logger.close();
    }
}