/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package edu.cmu.taghelpertools.gui.extractor;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.ListSelectionModel;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

/**
 * This GUI-related class is responsible for building and maintaining a JList for Bigrams.
 * @author haochuan
 *
 */
public class BigramListModel {

	private DefaultListModel dlm;
	private JList jlist;
	private String[] defaultWordList= new String[]{""};//{"what", "why", "how"};
	                                               
	public BigramListModel(MouseListener m)
	{
		this.dlm =  new DefaultListModel();
		this.jlist = new JList(this.dlm);
		this.jlist.addMouseListener(m);
		this.jlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		this.jlist.setDragEnabled(true);
		initModel();
	}

	public DefaultListModel getFunctionListModel()
	{
		return this.dlm;
	}
	
	public JList getJList()
	{
		return this.jlist;
	}
	
	public void addElement(String functionString)
	{
		this.dlm.addElement(functionString);
		this.jlist.repaint();
	}
	public void clearAll()
	{
		this.dlm.clear();
		this.jlist.repaint();
	}
	private void initModel()
	{
		for(int i=0; i<this.defaultWordList.length; i++)
		{
			String word = this.defaultWordList[i];
			this.addElement(word);
		}
	}
}
