/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package edu.cmu.taghelpertools.gui.extractor;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.ListSelectionModel;

import edu.cmu.taghelpertools.tokenizer.Tokenizer;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.*;

public class OtherFeatureListModel {

	private DefaultListModel dlm;
	private JList jlist;
	private static List<String> toolTips;		
	private static String[] defaultWordList;//= new String[]{"what", "why", "when", "where", "how"};
	private static boolean enable =true;
	private final static String ext_features_setting = "ext_features.txt";
	public void readFile()
	{
        /*check Chinese option*/
        File f = new File(ext_features_setting);
        if(f.exists())
        {
        	enable =true;
    		toolTips = new ArrayList<String>();   
        	try
        	{
        		List<String> tmpList = new ArrayList<String>();
        		BufferedReader rd = new BufferedReader(new FileReader(ext_features_setting));
        		String currentLine ="";
        		for(int i=0;(currentLine=rd.readLine())!=null; i++)
        		{
        			currentLine = currentLine.trim();
        			if(!currentLine.startsWith("#"))
        			{
        				tmpList.add(currentLine);
    					toolTips.add(currentLine);
        				
//        				String[] values = currentLine.split("=");
//        				if(values.length == 1)
//        				{
//        					tmpList.add(values[0].trim());
//        					toolTips.add(values[0].trim());        					
//        				}
//        				else if(values.length == 2)
//        				{
//        					tmpList.add(values[0].trim());
//        					toolTips.add(values[1].trim());
//        				}
        			}
        		}
        		defaultWordList = new String[tmpList.size()];        		
        		for(int i=0; i<tmpList.size(); i++)
        		{
        			defaultWordList[i] = tmpList.get(i);        			
        		}
        	}
        	catch(Exception ex)
        	{
        		System.err.println("\nError on loading external feature list: "+ext_features_setting+".");
        	}    		

        }
        else
        {
        	enable =false;
        	defaultWordList= new String[]{""};
        }
        

	}
	      
	public String getExpressionLight(int index)
	{
		return toolTips.get(index);
	}
	
	public OtherFeatureListModel(MouseListener m)
	{
		readFile();
		this.dlm =  new DefaultListModel();		
		this.jlist = new JList(this.dlm){
			public String getToolTipText(MouseEvent evt)
			{
				int index = locationToIndex(evt.getPoint());
				return toolTips.get(index);
			}
		};
		this.jlist.addMouseListener(m);
		this.jlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		if(enable == false)
		{
			this.jlist.setDragEnabled(false);
			this.jlist.setVisible(false);
		}
		else
		{
			initModel();
		}
	}

	public DefaultListModel getFunctionListModel()
	{
		return this.dlm;
	}
	
	public JList getJList()
	{
		return this.jlist;
	}
	
	public void addElement(String functionString)
	{
		this.dlm.addElement(functionString);
		this.jlist.repaint();
	}
	public void clearAll()
	{
		this.dlm.clear();
		this.jlist.repaint();
	}
	public void initModel()
	{
		for(int i=0; i<this.defaultWordList.length; i++)
		{
			String word = this.defaultWordList[i];
			this.addElement(word);
		}
	}
}
