/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package edu.cmu.taghelpertools.middle_layer;

public class FeatureGlobalProperty implements java.io.Serializable{
	
	private boolean isPOS;
	private boolean isBigram;
	private boolean isNonCountable;
	private boolean isUserDefined;
	private int globalCount;
	private String expression;
	
	public FeatureGlobalProperty(boolean isPOS, boolean isBigram, boolean isNonCountable, int initCount)
	{
		this.isBigram = isBigram;
		this.isPOS = isPOS;
		this.isNonCountable = isNonCountable;
		this.globalCount = initCount;
		this.expression = "";
	}
	
	public FeatureGlobalProperty(int initCount, String expression)
	{
		this.isUserDefined = true;
		this.isNonCountable = false;
		this.globalCount = initCount;
		this.expression = expression;
	}
	
	public void update(boolean isPOS, boolean isBigram)
	{
		this.isBigram = isBigram;
		this.isPOS = isPOS;
	}
	
	public void addCount()
	{
		this.globalCount++;
	}
	
	public boolean isNonCountable()
	{
		return this.isNonCountable;
	}
	
	public boolean isPOS()
	{
		return this.isPOS;
	}
	
	public boolean isBigram()
	{
		return this.isBigram;
	}
	
	public boolean isUserDefined()
	{
		return this.isUserDefined;
	}
	
	
	public int getCount()
	{
		return this.globalCount;
	}
	
	public String getExpression()
	{
		return this.expression;
	}
	
	public void setExpression(String exp)
	{
		this.expression = exp;
	}
}
