/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package edu.cmu.taghelpertools.middle_layer.extractor;

import java.util.List;

import edu.cmu.taghelpertools.middle_layer.DataPoint;
import edu.cmu.taghelpertools.middle_layer.FeatureSelector;
import edu.cmu.taghelpertools.middle_layer.extractor.FeatureSpaceMap.PositionLengthPair;

/**
 * This class is NO LONGER used.  
 * This is an early implementation for feature extraction.
 * This version is not degined for handling nesting expressions.
 * 
 * @author haochuan
 *
 */
public class FeatureExtractionHandler {
	
	private static final boolean DEBUG =false;
	private static List<DataPoint> dataPoints;
	private static FeatureSelector featureSelector;
	
	//for parser
	public static int method_code;
	public static int int_para;
	 	
	public static void removeFeature(String featureName)
	{
		//System.out.println("FEHander - removeFeature:  "+ featureName);
		FeatureExtractionHandler.featureSelector.removeGlobalUserDefiendFeature(featureName);
		for(int i=0; i<dataPoints.size(); i++)	//visit every data point
		{
			//System.out.println("FEHander - removeFeature:  " + i);
			DataPoint tmpPoint = dataPoints.get(i);
			FeatureSpaceMap fsm = tmpPoint.getFeatureSpaceMap();
			fsm.removeSyhtheticFeature(featureName);
			tmpPoint.unsetMatchedUserDefined(featureName);
		}
	}
	
	public static void setParameters(List<DataPoint> dataPoints, FeatureSelector featureSelector)
	{
		FeatureExtractionHandler.dataPoints = dataPoints;
		FeatureExtractionHandler.featureSelector = featureSelector;
	}

	public static void REPEAT(String ID, String feature, int times)
	{
		feature = feature.trim();
		//TODO: potentially creating a new feature named ID
		String expression = ID + "="+"REPEAT("+feature+","+times+")";

		if(DEBUG)
		{
			System.out.println("--> "+expression);
			return;
		}
		
		FeatureExtractionHandler.featureSelector.addGlobalUserDefiendFeature(ID, expression);
				
		for(int i=0; i<dataPoints.size(); i++)	//visit every data point
		{
			DataPoint tmpPoint = dataPoints.get(i);
			FeatureSpaceMap fsm = tmpPoint.getFeatureSpaceMap();
			fsm.removeSyhtheticFeatureIfNotMatched(ID, expression);
			PositionLengthPair record = fsm.getOrdFeature(feature); // see if the feature ever occured 
			
			if(record!=null) // if occured 
			{
				List<Integer> ll = record.getPositionList();	
				for(int j=0; j<ll.size(); j++)
				{
					int startPosition = ll.get(j).intValue();
					if(times > 1)
					{
						boolean valid = false;
						for(int k=startPosition+1; k<startPosition+times; k++)
						{
							valid = record.occurAt(k);
						}
						
						if(valid)
						{
							fsm.addSyntheticFeature(ID, expression, startPosition, times);						
						}
					}
					else
					{
						fsm.addSyntheticFeature(ID, expression,startPosition, times);
					}
				}
			}
			else
			{
				continue;
			}
		}
	}
	
	public static void COLLOCATE(String ID, String features)
	{
		String[] values = features.split("\\%");
		String feature1= values[0].trim();
		String feature2 = values[1].trim();
		String expression = ID + "="+"COLLOCATE("+feature1+","+feature2+")";
		
		if(DEBUG)
		{
			System.out.println("--> "+expression);
			return;
		}	
		
		FeatureExtractionHandler.featureSelector.addGlobalUserDefiendFeature(ID, expression);
					
		for(int i=0; i<dataPoints.size(); i++)	//visit every data point
		{		
			DataPoint tmpPoint = dataPoints.get(i);
			FeatureSpaceMap fsm = tmpPoint.getFeatureSpaceMap();
			fsm.removeSyhtheticFeatureIfNotMatched(ID, expression);
			
			PositionLengthPair record1 = fsm.getOrdFeature(feature1); // see if the feature ever occured 
			PositionLengthPair record2 = fsm.getOrdFeature(feature2); // see if the feature ever occured
			
			if(record1!=null && record2 != null)
			{
				List<Integer> ll = record1.getPositionList();
				for(int j=0; j<ll.size(); j++)
				{
					int tmpPosition1 = ll.get(j).intValue();
					if(record2.occurAt(tmpPosition1))
					{
						fsm.addSyntheticFeature(ID, expression, tmpPosition1, fsm.NOT_COUNTABLE);							
					}
				}
			}
			else
			{
				continue;
			}
		}
	}
//	
//	public static void ANY(String ID, String features)
//	{
//		String[] values = features.split("\\%");
//		String expression = ID + "="+"ANY(";
//		for(int i=0; i<values.length; i++)
//		{
//			expression = expression+values[i].trim();
//			if(i!=values.length -1)
//			{
//				expression = expression+",";
//			}		
//		}
//		expression = expression +")";
//		
//		if(DEBUG)
//		{
//			System.out.println("--> "+expression);
//			return;
//		}	
//		
//		FeatureExtractionHandler.featureSelector.addGlobalUserDefiendFeature(ID, expression);
//		
//		for(int i=0; i<dataPoints.size(); i++)	//visit every data point
//		{		
//			DataPoint tmpPoint = dataPoints.get(i);
//			FeatureSpaceMap fsm = tmpPoint.getFeatureSpaceMap();
//			fsm.removeSyhtheticFeatureIfNotMatched(ID, expression);			
//			
//			for(int j=0; j<values.length; j++)
//			{
//				PositionLengthPair tmpRecord = fsm.getOrdFeature(values[j].trim());
//				if(tmpRecord != null)
//				{
//					fsm.addSyntheticFeature(ID, expression, fsm.NOT_COUNTABLE, fsm.NOT_COUNTABLE);					
//					break;
//				}
//			}
//		}		
//	}
	public static void ANY(String ID, String features)
	{
		String[] values = features.split("\\%");
		String expression = ID + "="+"ANY(";
		for(int i=0; i<values.length; i++)
		{
			expression = expression+values[i].trim();
			if(i!=values.length -1)
			{
				expression = expression+",";
			}		
		}
		expression = expression +")";
		
		if(DEBUG)
		{
			System.out.println("--> "+expression);
			return;
		}	
		
		FeatureExtractionHandler.featureSelector.addGlobalUserDefiendFeature(ID, expression);
		
		for(int i=0; i<dataPoints.size(); i++)	//visit every data point
		{		
			DataPoint tmpPoint = dataPoints.get(i);
			FeatureSpaceMap fsm = tmpPoint.getFeatureSpaceMap();
			fsm.removeSyhtheticFeatureIfNotMatched(ID, expression);			
			
			for(int j=0; j<values.length; j++)
			{
				PositionLengthPair tmpRecord = fsm.getOrdFeature(values[j].trim());
				PositionLengthPair tmpRecord2 = fsm.getSynFeature(values[j].trim());	//syn
				if(tmpRecord != null || tmpRecord2 !=null)
				{
					fsm.addSyntheticFeature(ID, expression, fsm.NOT_COUNTABLE, fsm.NOT_COUNTABLE);					
					break;
				}
			}
		}		
	}
//	public static void ALL(String ID, String features)
//	{
//		String[] values = features.split("\\%");
//		String expression = ID + "="+"ALL(";
//		for(int i=0; i<values.length; i++)
//		{
//			expression = expression+values[i].trim();
//			if(i!=values.length -1)
//			{
//				expression = expression+",";
//			}		
//		}
//		expression = expression +")";
//		
//		if(DEBUG)
//		{
//			System.out.println("--> "+expression);
//			return;
//		}	
//		
//		FeatureExtractionHandler.featureSelector.addGlobalUserDefiendFeature(ID, expression);
//		
//		for(int i=0; i<dataPoints.size(); i++)	//visit every data point
//		{		
//			DataPoint tmpPoint = dataPoints.get(i);
//			FeatureSpaceMap fsm = tmpPoint.getFeatureSpaceMap();
//			fsm.removeSyhtheticFeatureIfNotMatched(ID, expression);			
//			
//			boolean goodSoFar = false;
//			for(int j=0; j<values.length; j++)
//			{
//				PositionLengthPair tmpRecord = fsm.getOrdFeature(values[j].trim());
//				if(tmpRecord != null)
//				{
//					goodSoFar = true;					
//				}
//				else
//				{
//					goodSoFar = false;
//					break;
//				}
//			}
//			
//			if(goodSoFar)
//				fsm.addSyntheticFeature(ID, expression, fsm.NOT_COUNTABLE, fsm.NOT_COUNTABLE);			
//		}			
//	}	
	public static void ALL(String ID, String features)
	{
		String[] values = features.split("\\%");
		String expression = ID + "="+"ALL(";
		for(int i=0; i<values.length; i++)
		{
			expression = expression+values[i].trim();
			if(i!=values.length -1)
			{
				expression = expression+",";
			}		
		}
		expression = expression +")";
		
		if(DEBUG)
		{
			System.out.println("--> "+expression);
			return;
		}	
		
		FeatureExtractionHandler.featureSelector.addGlobalUserDefiendFeature(ID, expression);
		
		for(int i=0; i<dataPoints.size(); i++)	//visit every data point
		{		
			DataPoint tmpPoint = dataPoints.get(i);
			FeatureSpaceMap fsm = tmpPoint.getFeatureSpaceMap();
			fsm.removeSyhtheticFeatureIfNotMatched(ID, expression);			
			
			boolean goodSoFar = false;
			for(int j=0; j<values.length; j++)
			{
				PositionLengthPair tmpRecord = fsm.getOrdFeature(values[j].trim());
				PositionLengthPair tmpRecord2 = fsm.getSynFeature(values[j].trim());
				if(tmpRecord != null || tmpRecord2 !=null)
				{
					goodSoFar = true;					
				}
				else
				{
					goodSoFar = false;
					break;
				}
			}
			
			if(goodSoFar)
				fsm.addSyntheticFeature(ID, expression, fsm.NOT_COUNTABLE, fsm.NOT_COUNTABLE);			
		}			
	}	
	public static void CONCATENATE(String ID, String features)
	{
		String[] values = features.split("\\%");
		String expression = ID + "="+"CONCATENATE(";
		for(int i=0; i<values.length; i++)
		{
			expression = expression+values[i].trim();
			if(i!=values.length -1)
			{
				expression = expression+",";
			}		
		}
		expression = expression +")";
		
		if(DEBUG)
		{
			System.out.println("--> "+expression);
			return;
		}	
		
		FeatureExtractionHandler.featureSelector.addGlobalUserDefiendFeature(ID, expression);
		
		for(int i=0; i<dataPoints.size(); i++)	//visit every data point
		{		
			DataPoint tmpPoint = dataPoints.get(i);
			FeatureSpaceMap fsm = tmpPoint.getFeatureSpaceMap();
			fsm.removeSyhtheticFeatureIfNotMatched(ID, expression);			
			PositionLengthPair firstRecord = fsm.getOrdFeature(values[0].trim());
			if(firstRecord == null)
				continue;
			
			List<Integer> ll = firstRecord.getPositionList();
			List<Integer> mm = firstRecord.getLengthList();
			
			boolean goodSoFar = false;
			for(int j=0; j<ll.size(); j++)
			{
				int position = ll.get(j).intValue();
				int length = mm.get(j).intValue();
				int expectPosition = position + length;
				
				for(int k=1; k<values.length; k++)
				{
					PositionLengthPair tmpRecord = fsm.getOrdFeature(values[k].trim());					
					if(tmpRecord != null) 
					{
						int index = tmpRecord.occurAt(expectPosition, true);
						if(index >-1)
						{
							goodSoFar = true;
							
							position = tmpRecord.getPositionList().get(index).intValue();
							length = tmpRecord.getLengthList().get(index).intValue();
							expectPosition = position + length;							
						}
						else
						{
							goodSoFar =false;
						}
					}
					else
					{
						goodSoFar = false;	
					}
					if(!goodSoFar)
						break;
				}
				if(!goodSoFar)
					continue;
			}
			
			
			if(goodSoFar)
				fsm.addSyntheticFeature(ID, expression, fsm.NOT_COUNTABLE, fsm.NOT_COUNTABLE);			
		}			
	}
	
	public static void ORDER(String ID, String features)
	{
		String[] values = features.split("\\%");
		String expression = ID + "="+"ORDER(";
		for(int i=0; i<values.length; i++)
		{
			expression = expression+values[i].trim();
			if(i!=values.length -1)
			{
				expression = expression+",";
			}		
		}
		expression = expression +")";
		
		if(DEBUG)
		{
			System.out.println("--> "+expression);
			return;
		}	
		
		FeatureExtractionHandler.featureSelector.addGlobalUserDefiendFeature(ID, expression);
		
		for(int i=0; i<dataPoints.size(); i++)	//visit every data point
		{		
			DataPoint tmpPoint = dataPoints.get(i);
			FeatureSpaceMap fsm = tmpPoint.getFeatureSpaceMap();
			fsm.removeSyhtheticFeatureIfNotMatched(ID, expression);			
			PositionLengthPair firstRecord = fsm.getOrdFeature(values[0].trim());
			if(firstRecord == null)
				continue;
			
			List<Integer> ll = firstRecord.getPositionList();
			List<Integer> mm = firstRecord.getLengthList();
			
			boolean goodSoFar = false;
			for(int j=0; j<ll.size(); j++)
			{
				int position = ll.get(j).intValue();
				int length = mm.get(j).intValue();
				int expectPosition = position + length;
				
				for(int k=1; k<values.length; k++)
				{
					PositionLengthPair tmpRecord = fsm.getOrdFeature(values[k].trim());					
					if(tmpRecord != null) 
					{
						int index = tmpRecord.occurAfter(expectPosition, true);
						if(index >-1)
						{
							goodSoFar = true;
							
							position = tmpRecord.getPositionList().get(index).intValue();
							length = tmpRecord.getLengthList().get(index).intValue();
							expectPosition = position + length;							
						}
						else
						{
							goodSoFar =false;
						}
					}
					else
					{
						goodSoFar = false;	
					}
					if(!goodSoFar)
						break;
				}
				if(!goodSoFar)
					continue;
			}
			
			
			if(goodSoFar)
				fsm.addSyntheticFeature(ID, expression, fsm.NOT_COUNTABLE, fsm.NOT_COUNTABLE);			
		}	
	}
	
	public static void WINDOW(String ID, String features, int size)
	{
		String[] values = features.split("\\%");
		String expression = ID + "="+"WINDOW(";
		for(int i=0; i<values.length; i++)
		{
			expression = expression+values[i];
			expression = expression+", ";
			expression = expression + size;		
		}
		expression = expression +")";
		
		if(DEBUG)
		{
			System.out.println("--> "+expression);
			return;
		}		
	}
	
	public static void main(String[] args)
	{
		String input = "1%2%abc@4";
		String[] values = input.split("\\@");
		for(int i =0; i<values.length; i++)
			System.out.println(values[i]);
		
		for(int i=0; i<10; i++)
		{
			for(int j=0; j<10; j++)
			{
				if(j==6)
					continue;
				
				System.out.println("i="+i+", j="+j);

			}
		}
	}
}
