package edu.cmu.taghelpertools.middle_layer.util;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Iterator;

import edu.cmu.taghelpertools.middle_layer.util.SimpleFeatureSpaceBuilder;

/**
 * Tester is an example of using SimpleFeatureSpaceBuilder for extracting 
 * features from given texts. This is intended to serve as an example of how to 
 * use the simple programming interface.  The source code Tester.java can be found
 * in the main folder of TagHelperTools2. 
 * 
 * 
 * @author Hao-Chuan Wang
 * 
 */
public class Tester2 {
	public static void main(String[] args)
	{
		ArrayList texts = new ArrayList();
        texts.add("You should separate, until the offspring are bigger the female should stay with them alone until they are stronger and then the male can join. ".trim().toLowerCase());
        texts.add("When bunnies are raised in captivity, when they are domesticated, there is no seasonality to breeding, and the females can be pregnant all the time even while breastfeeding the previous litter. If we leave the male, the female will become pregnant again and this will exhaust her, it might hurt the cubs that are already born and she might also not care for the additional litter. You simply must protect the females and separate. ".trim().toLowerCase());
        
        //String options_before = "-lang eng -f uni -f bi -f posbi -f ll -stop";
        
        String options1 = "-lang eng -rt 2 -f uni";
        String options2 = "-lang eng -f posbi -f cns";
        
		SimpleFeatureSpaceBuilder sf = new SimpleFeatureSpaceBuilder(options1);
		ArrayList allAtts = sf.build(texts);		
		System.out.println("\n\nAttributes:\n"+allAtts);
		System.out.println("Numeric Attributes:\n"+sf.getNumericFeatures()+"\n\n");		
		
		String text = "When bunnies are raised in captivity, when they are domesticated, there is no seasonality to breeding, and the females can be pregnant all the time even while breastfeeding the previous litter. If we leave the male, the female will become pregnant again and this will exhaust her, it might hurt the cubs that are already born and she might also not care for the additional litter. You simply must protect the females and separate. ".trim().toLowerCase();
		
		//get binary features for the given text
		Iterator itr = sf.getBinaryFeatureIterator(text);
		System.out.println("\nBinary attributes for the given text: ");	
		while(itr.hasNext())
		{
			System.out.println(itr.next().toString());
		}
		
		//get names of numeric features
		System.out.println("\nNumeric attributes for the given text: ");			
		ArrayList nfNames = sf.getNumericFeatures();
		ArrayList<Double> numericFeatures = sf.getNumericFeatureValues(text, nfNames);
		
		for(int i=0; i<numericFeatures.size(); i++)
		{
			System.out.println(nfNames.get(i)+"= "+numericFeatures.get(i));
		}
	}
}
