/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*only for the German version*/
package edu.cmu.taghelpertools.tokenizer;

import java.io.*;
import opennlp.maxent.*;
import opennlp.maxent.io.*;
import opennlp.tools.ngram.*;
import opennlp.tools.postag.*;

public class GermanPOSTagger extends POSTaggerME {

    public GermanPOSTagger(String modelfile, Dictionary tags) {
        super(getModel(modelfile), tags);
    }

    private static MaxentModel getModel(String modelfile) {
        try {
            return new SuffixSensitiveGISModelReader(new File(modelfile)).getModel();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
            return null;
        }
    }

    public static void main(String[] args) throws IOException {
        GermanPOSTagger tagger = new GermanPOSTagger("etc/de-tiger-pos", null);
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        for (String line = in.readLine(); line != null; line = in.readLine()) {
            System.out.println(tagger.tag(line));
        }
    }
}
