/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package edu.cmu.taghelpertools.util;


public class GenericNode {
	
	public static final char POS = '+';
	public static final char NEG = '-';
	public static final char NONE = '*';

	private Object o;
	private double weight;
	private char sign;
	
	public GenericNode(Object o, double weight){
		this.o = o;
		this.weight  = weight;
		this.sign = NONE;
	}
	
	public  GenericNode(Object o, double weight, char sign){
		this.o = o;
		this.weight = weight;
		this.sign = sign;
	}
	
	public Object getO(){
		return o;
	}
	
	public void setO(Object o){
		this.o = o;
	}
	
	public double getWeight(){
		return weight;
	}
	
	public void setWeight(double weight){
		this.weight = weight;
	}
	
	public String toString(){
		return o + ":" + weight; 
	}
	
	public char getSign(){
		return sign;
	}



}
